/// <reference types="bn.js" />
/// <reference types="@project-serum/anchor/node_modules/@solana/web3.js" />
import { Keypair, PublicKey } from '@solana/web3.js';
import { LiquidityIncentiveClient } from '../../client/liquidityIncentiveProgram';
import { DepositState, ErrorCB } from '../../types';
import { StateUpdateHandler } from '../../types/index';
import { Campaign } from './campaign';
import { BN } from '@project-serum/anchor';
import { Pool, PoolNode } from '../cypher';
export declare class Deposit {
    readonly client: LiquidityIncentiveClient;
    readonly address: PublicKey;
    state: DepositState;
    private _onStateUpdate?;
    private _errorCallback?;
    private _listener;
    constructor(client: LiquidityIncentiveClient, address: PublicKey, state: DepositState, _onStateUpdate?: StateUpdateHandler<DepositState>, _errorCallback?: ErrorCB);
    static create(client: LiquidityIncentiveClient, campaign: Campaign, pool: Pool, poolNode: PoolNode, fundingAccount: PublicKey, amount: BN): Promise<{
        deposit: PublicKey;
        ixs: import("@solana/web3.js").TransactionInstruction[];
        signers: Keypair[];
    }>;
    end(client: LiquidityIncentiveClient, campaign: Campaign, pool: Pool, poolNode: PoolNode, assetTokenAccount: PublicKey): Promise<{
        deposit: PublicKey;
        ixs: import("@solana/web3.js").TransactionInstruction[];
        signers: Keypair[];
    }>;
    static load(client: LiquidityIncentiveClient, address: PublicKey, onStateUpdateHandler?: StateUpdateHandler<DepositState>, errorCallback?: ErrorCB): Promise<Deposit>;
    subscribe(): void;
    private addListener;
    private removeListener;
    unsubscribe(): Promise<void>;
}
