"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CypherClient = void 0;
const anchor_1 = require("@project-serum/anchor");
const faucet_1 = require("./faucet");
const constants_1 = require("../constants");
const cypher_json_1 = __importDefault(require("../generated/idl/cypher.json"));
const client_1 = require("./client");
class CypherClient extends client_1.ProgramClient {
    constructor(cluster, rpcEndpoint, wallet, confirmOpts = anchor_1.AnchorProvider.defaultOptions()) {
        super(cypher_json_1.default, constants_1.CONFIGS[cluster].CYPHER_PID, rpcEndpoint, wallet, confirmOpts);
        this.cluster = cluster;
        if (this.cluster !== 'mainnet-beta') {
            this.faucet = new faucet_1.FaucetClient(this.cluster, rpcEndpoint, wallet, confirmOpts);
        }
    }
    get cypherPID() {
        return constants_1.CONFIGS[this.cluster].CYPHER_PID;
    }
    get dexPID() {
        return constants_1.CONFIGS[this.cluster].DEX_PID;
    }
    get quoteMint() {
        return constants_1.CONFIGS[this.cluster].QUOTE_MINT;
    }
}
exports.CypherClient = CypherClient;
//# sourceMappingURL=cypher.js.map