import { Keypair, TransactionInstruction, PublicKey } from '@solana/web3.js';
import { CypherClient } from '../client';
import { AnchorProvider } from '@project-serum/anchor';
export declare const makeCreateMarketAccountsIxs: (client: CypherClient) => Promise<{
    orderbook: PublicKey;
    eventQueue: PublicKey;
    bids: PublicKey;
    asks: PublicKey;
    priceHistory: PublicKey;
    ixs: TransactionInstruction[];
    signers: Keypair[];
}>;
export declare const makeRequestCuIx: (payer: PublicKey, units: number) => TransactionInstruction;
export declare const makeCreateMintIxs: (provider: AnchorProvider, authority: PublicKey, mint: PublicKey, decimals?: number) => Promise<TransactionInstruction[]>;
export declare const makeCreateTokenAccountIxs: (provider: AnchorProvider, newAccountPubkey: PublicKey, mint: PublicKey, owner: PublicKey, lamports?: number) => Promise<TransactionInstruction[]>;
